((
$Date: 2008-09-27 18:19:05 +0200 (sb, 27 sep 2008) $
$Revision: 586 $
$Author: astrorafael $
$HeadURL: svn://localhost/repos/vfx/forthql/tags/forthql-1.0/test/test1.fs $

2008 By Rafael Gonzalez Fuentetaja
This file is placed in the public domain. NO WARRANTY.
))

include /usr/share/doc/VfxForth/Lib/Genio/Buffer.fth
\ include /usr/share/doc/VfxForth/Lib/Ndp387.fth

include ../src/sqlite3.fs
include ../src/forthql.fs

sql-dry-run off

: table-creation
   SQL| CREATE TABLE IF NOT EXISTS Person(
      name TEXT PRIMARY KEY, surname TEXT, age INTEGER);
   |SQL.
;

: see-persons
   SQL| SELECT * FROM Person; |SQL.
;

struct /Person
   16 chars field Person.name
   16 chars field Person.surname
    1 cells field Person.age
end-struct 


: initPerson				  \ ca1 u1 ca2 u2 n3 person --
   >R
   R@ Person.age !
   R@ Person.surname place
   R> Person.name    place
;

: Person:				  \  ca1 u1 ca2 u2 n3 "name"
   Create here
   /person allot&erase
   initPerson
;

: quote [char] ' emit ;


: [qtype]   ( ca u -- )
   postpone quote
   postpone type
   postpone quote
; immediate


   
:noname                                 \ person --
   [sqlio Person.name count [qtype] sqlio]
; 16 chars SQLParameter: /name/


:noname                                 \ person --
   [sqlio Person.surname count [qtype] sqlio]
; 16 chars SQLParameter: /surname/


:noname                                 \ person --
   [sqlio  Person.age ? sqlio]
; 8 chars SQLParameter: /age/


: save-person   ( person -- )
   SQL| INSERT OR REPLACE INTO Person
   VALUES( | dup /name/ |  , | dup /surname/ | , | /age/ | );
   |SQL.
;

: "Homer"   s" Homer"   ;
: "Maggie"  s" Maggie"  ;
: "Bart"    s" Bart"    ;
: "Simpson" s" Simpson" ;

s" simpson.db" db-open db-throw table-creation

see-persons

"Homer"  "Simpson" 43 Person: Homer
"Maggie" "Simpson" 40 Person: Maggie
"Bart"   "Simpson" 14 Person: Bart

Homer  save-person
Maggie save-person
Bart   save-person

see-persons

db-close
