((
$Date: 2008-09-27 18:19:05 +0200 (sb, 27 sep 2008) $
$Revision: 586 $
$Author: astrorafael $
$HeadURL: svn://localhost/repos/vfx/forthql/tags/forthql-1.0/test/test2.fs $

2008 By Rafael Gonzalez Fuentetaja
This file is placed in the public domain. NO WARRANTY.
))

include /usr/share/doc/VfxForth/Lib/Genio/Buffer.fth
include /usr/share/doc/VfxForth/Lib/Ndp387.fth

include ../externals/objects/struct.fs
include ../externals/objects/objects.fs
include ../externals/extras/string.fs

include ../src/sqlite3.fs
include ../src/forthql.fs

sql-dry-run off

: quote [char] ' emit ;
: [qtype]   ( ca u -- )
   postpone quote
   postpone type
   postpone quote
; immediate

: creation
   SQL| CREATE TABLE IF NOT EXISTS Person(
      name TEXT PRIMARY KEY, surname TEXT, age INTEGER);
   |SQL.
;

: persons
   SQL| SELECT * FROM Person; |SQL.
;

object class
   cell% inst-var m-name
   cell% inst-var m-surname
   cell% inst-var m-age
end-class Person

Person methods

protected

  :noname                                 \ ca1 u1 --
    [sqlio m-name $@ [qtype] sqlio]
  ; 16 chars SQLParameter: /name/

  :noname                                 \ ca1 u1 --
    [sqlio m-surname $@ [qtype] sqlio]
  ; 16 chars SQLParameter: /surname/

  :noname                                 \ ca1 u1 --
    [sqlio  m-age ? sqlio]
  ; 8 chars SQLParameter: /age/

    \ ----------------------------------------------------
  :m (refresh)  ( colValue** this -- )
    0 sql3-$@ evaluate m-age !
  ;m

  :noname   \ object* nCols colValue** colName** -- ior
    drop nip swap (refresh)
    SQLITE_OK
  ; SQLite3Callback: <<refresh>>


public
 
  m:   ( ca1 u1 ca2 u2 age this -- ) \ overrides construct
    0 dup m-name ! m-surname !
    m-age ! m-surname $! m-name $!
  ;m overrides construct
  
  :m save-person   ( this -- )
     SQL| INSERT OR REPLACE INTO Person
     VALUES( | /name/ |  , | /surname/ | , | /age/ | );
     |SQL.
  ;m

  :m refresh ( this -- )
     ." Refresing age from database for " m-name $@ type cr
    SQL| SELECT age FROM Person WHERE name = | /name/
    |SQL>> this <<refresh>>
  ;m

end-methods

: Homer   s" Homer" ;
: Maggie  s" Maggie" ;
: Bart    s" Bart" ;
: Simpson s" Simpson" ;

Homer  Simpson 43 Person heap-new constant p1
Maggie Simpson 40 Person heap-new constant p2
Bart   Simpson 14 Person heap-new constant p3

s" simpson.db" db-open db-throw creation

p1 save-person
p2 save-person
p3 save-person
p1 refresh
